﻿using System.Security.Cryptography.X509Certificates;
using FitConnect.BaseClasses;
using FitConnect.Models;
using FitConnect.Services.Models;
using Microsoft.Extensions.Logging;

namespace FitConnect;

public class Sender : FunctionalBaseClass {
    public Sender(FitConnectEndpoints endpoints,
        X509Certificate2? certificate = null, ILogger? logger = null) : base(logger, endpoints,
        certificate) {
    }


    /// <summary>
    ///     Check public keys
    /// </summary>
    /// <returns></returns>
    public async Task<bool> CheckPublicKeyAsync(string publicKey) {
        throw new NotImplementedException();
    }

    public async Task<string> Encrypt(string publicKey, byte[] attachment) {
        throw new NotImplementedException();
    }


    /// <summary>
    ///     Create Metadata incl. Hash
    /// </summary>
    /// <param name="data"></param>
    /// <param name="attachment"></param>
    /// <returns></returns>
    public async Task<string>
        CreateMetadataAsync(string data, string attachment, string publicKey) {
        throw new NotImplementedException();
    }

    /// <summary>
    ///     Check public keys
    /// </summary>
    /// <returns></returns>
    public async Task<bool> CheckPublicKeyAsync() {
        throw new NotImplementedException();
    }

    /// <summary>
    ///     Encrypt Data
    /// </summary>
    /// <param name="data"></param>
    /// <returns></returns>
    public string Encrypt(string publicKey, string? data) {
        if (data == null) return "";
        throw new NotImplementedException();
    }

    /// <summary>
    ///     Encrypt attachments (Anhänge)
    /// </summary>
    /// <param name="publicKey"></param>
    /// <param name="attachment"></param>
    /// <returns></returns>
    public KeyValuePair<string, string> Encrypt(string publicKey, Attachment attachment) {
        throw new NotImplementedException();
    }

    /// <summary>
    ///     Create Metadata incl. Hash
    /// </summary>
    /// <param name="data"></param>
    /// <param name="attachment"></param>
    /// <returns></returns>
    public async Task<string> CreateMetadataAsync(string data, byte[] attachment) {
        throw new NotImplementedException();
    }

    public CreateSubmissionDto CreateSubmissionDto(Submission submission) {
        return new() {
            DestinationId = submission.DestinationId,
            ServiceType = (ServiceTypeDto)submission.ServiceType,
            AnnouncedAttachments = submission.Attachments.Select(a => a.Id).ToList()
        };
    }

    public async Task UploadAttachmentsAsync(
        List<KeyValuePair<string, string>> encryptedAttachments) {
        throw new NotImplementedException();
    }

    public async Task SubmitSubmissionAsync(Submission submission) {
        throw new NotImplementedException();
    }

    public Task<string> GetDestinationIdAsync(string leiaKey, string? ags, string? ars,
        string? areaId) {
        return ApiService.RouteService.GetDestinationIdAsync(leiaKey, ags, ars, areaId);
    }
}
